Name: sysklogd
Version: 1.4.1
Release: alt12.1

%define syslog_name syslogd
%define klogd_name klogd
%define ROOT %_localstatedir/%klogd_name

Summary: Base package for system logging and kernel message trapping daemons
License: GPL
Group: System/Kernel and hardware
Url: ftp://ftp.ibiblio.org/pub/Linux/system/daemons/

Source0: %name-%version.tar.bz2
Source1: syslog.conf
Source2: syslogd.log
Source3: syslogd.init
Source4: syslogd.sysconfig
Source5: klogd.init
Source6: klogd.sysconfig
Source7: %name-update
Source8: reload-syslog

# RH
Patch1: %name-1.3-31-rh-alpha.patch
Patch2: %name-1.3-31-rh-alt-Makefile.patch
Patch3: %name-1.3-31-rh-utmp.patch
Patch4: %name-1.3-31-rh-ksyslog-nul.patch
Patch5: %name-1.3-31-rh-ksymless.patch

# ALT
Patch11: %name-1.4.1-alt-klogd-reopenlog.patch
Patch12: %name-1.4.1-alt-owl-syslogd-killing.patch

# Owl
Patch21: %name-1.4.1-owl-longjmp.patch
Patch22: %name-1.4.1-owl-syslogd-create-mode.patch
Patch23: %name-1.4.1-caen-owl-syslogd-bind.patch
Patch24: %name-1.4.1-caen-owl-syslogd-drop-root.patch
Patch25: %name-1.4.1-caen-owl-klogd-drop-root.patch

# ALT
Patch31: %name-1.4.1-alt-syslogd-chroot.patch
Patch32: %name-1.4.1-alt-funix_dir.patch

PreReq: %syslog_name = %version-%release, %klogd_name = %version-%release
Conflicts: logrotate < 3.3-ipl9mdk, vixie-cron < 3.0.1-ipl45mdk

BuildPreReq: coreutils

%description
This is a generic virtual package.
It's require two system utilities (syslogd and klogd) which provide support for system logging.
%syslog_name and %klogd_name run as daemons (background processes) and log system messages
to different places, like sendmail logs, security logs, error logs, etc.

%package -n %syslog_name
Summary: System logging daemon (%syslog_name)
Group: System/Kernel and hardware
Provides: %syslog_name-daemon
PreReq: coreutils, grep, chkconfig, initscripts, syslog-common = %version-%release

%description -n %syslog_name
This package contains %syslog_name wich provide support for system logging.

%package -n %klogd_name
Summary: Kernel message trapping daemon (%klogd_name)
Group: System/Kernel and hardware
PreReq: %syslog_name-daemon, shadow-utils, chkconfig, initscripts
Conflicts: %syslog_name < %version-%release

%description -n %klogd_name
This package contains %klogd_name wich provide support for system logging.

%package -n syslog-common
Summary: Common stuff for system logs
Group: System/Kernel and hardware
Provides: /etc/syslog.d

%description -n syslog-common
This package contains log directories structure and logrotate scripts both for
classic syslog and syslog-ng.

%prep
%setup -q
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1

%patch11 -p1
%patch12 -p1

%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1

%patch31 -p1
%patch32 -p1

%build
%add_optflags -D_FILE_OFFSET_BITS=64
%make_build

%install
mkdir -p $RPM_BUILD_ROOT{%_mandir/man{5,8},/sbin}

%makeinstall TOPDIR=$RPM_BUILD_ROOT MANDIR=$RPM_BUILD_ROOT%_mandir

install -pD -m640 %SOURCE1 $RPM_BUILD_ROOT%_sysconfdir/syslog.conf
install -pD -m640 %SOURCE2 $RPM_BUILD_ROOT%_sysconfdir/logrotate.d/syslog
install -pD -m755 %SOURCE3 $RPM_BUILD_ROOT%_initdir/syslogd
install -pD -m640 %SOURCE4 $RPM_BUILD_ROOT%_sysconfdir/sysconfig/%syslog_name

install -pD -m755 %SOURCE5 $RPM_BUILD_ROOT%_initdir/%klogd_name
install -pD -m640 %SOURCE6 $RPM_BUILD_ROOT%_sysconfdir/sysconfig/%klogd_name

install -pD -m755 %SOURCE7 $RPM_BUILD_ROOT%_sysconfdir/rc.d/scripts/%name-update

chmod 755 $RPM_BUILD_ROOT/sbin/*
mkdir -p $RPM_BUILD_ROOT%_logdir/{kernel,user,mail,daemons,auth,lpr,news,uucp,cron,ftp,syslog}
ln -s syslog/alert $RPM_BUILD_ROOT%_logdir/alert
ln -s syslog/boot $RPM_BUILD_ROOT%_logdir/boot.log
ln -s mail/all $RPM_BUILD_ROOT%_logdir/maillog
ln -s syslog/messages $RPM_BUILD_ROOT%_logdir/messages
ln -s auth/secure $RPM_BUILD_ROOT%_logdir/secure
ln -s syslog/spooler $RPM_BUILD_ROOT%_logdir/spooler

/bin/ls -1 $RPM_BUILD_ROOT%_logdir |fgrep -v uucp |sed -e 's|.*|%attr(-,root,adm) %_logdir/&|g' >%name.files

chmod -R o-rwx $RPM_BUILD_ROOT%_logdir

install -pD -m700 %SOURCE8 $RPM_BUILD_ROOT/sbin/reload-syslog
mkdir -p -m700 $RPM_BUILD_ROOT%_sysconfdir/syslog.d
ln -s %ROOT/dev/log $RPM_BUILD_ROOT%_sysconfdir/syslog.d/klogd

#chroot stuff
mkdir -p $RPM_BUILD_ROOT/%ROOT/dev
mksock $RPM_BUILD_ROOT%ROOT/dev/log

%pre -n syslog-common
# Because RPM doesn't know the difference between files and directories,
# we need to verify if there is no file with the same name as the directory
# to be created for the new logdir architecture.
# If the name is the same and it is a file, rename it to name.old

for f in kernel user mail daemons auth lpr news uucp cron ftp syslog; do
	if [ -f "%_logdir/$f" -a ! -L "%_logdir/$f" ]; then
		%__mv -f "%_logdir/$f" "%_logdir/$f.old" &&
			%__mkdir "%_logdir/$f" &&
			%__mv "%_logdir/$f.old" "%_logdir/$f"
	fi
done ||:

# Same comment about compatibility links.
for f in alert boot.log maillog messages secure spooler; do
	if [ -f "%_logdir/$f" -a ! -L "%_logdir/$f" ]; then
		%__mv -f "%_logdir/$f" "%_logdir/$f.old"
	fi
done ||:

%triggerpostun -- %name <= 1.4.1-alt3
if [ $1 -gt 1 ]; then
	%_sysconfdir/rc.d/scripts/%name-update
fi

%post -n syslog-common
cd %_logdir
# Create each log directory with logfiles.
for f in \
	{kernel,user,mail,daemons,lpr,news,uucp,cron,ftp}/{info,warnings,errors} \
	auth/{all,messages,secure} mail/all \
	syslog/{messages,alert,spooler,boot,sudo}
do
	if [ ! -f "$f" ]; then
		:>>"$f"
		%__chgrp adm "$f"
		%__chmod 640 "$f"
	fi
done ||:

%pre -n %syslog_name
/usr/sbin/groupadd -r -f syslogd
/usr/sbin/useradd -r -g syslogd -d /dev/null -s /dev/null -n syslogd &> /dev/null ||:

%post -n %syslog_name
%post_service syslogd

%preun -n %syslog_name
%preun_service syslogd
%pre -n %klogd_name
/usr/sbin/groupadd -r -f klogd
/usr/sbin/useradd -r -g klogd -d /dev/null -s /dev/null -n klogd &> /dev/null ||:

%post -n %klogd_name
%post_service %klogd_name

%preun -n %klogd_name
%preun_service %klogd_name
%files
%_sysconfdir/rc.d/scripts/%name-update

%files -n %klogd_name
%config %_initdir/%klogd_name
%config(noreplace) %_sysconfdir/sysconfig/%klogd_name
%_sysconfdir/syslog.d/klogd
/sbin/%klogd_name
%_mandir/man?/%{klogd_name}*
%attr(710,root,klogd) %dir %ROOT
%attr(710,root,klogd) %dir %ROOT/dev
%attr(666,root,root) %ghost %ROOT/dev/log

%files -n %syslog_name
%config(noreplace) %attr(640,root,adm) %_sysconfdir/syslog.conf
%config(noreplace) %_sysconfdir/sysconfig/%syslog_name
%config %_initdir/syslogd
/sbin/syslog*
%doc ANNOUNCE README* NEWS

%_mandir/man?/sys*

%files -n syslog-common -f %name.files
%attr(700,root,root) %dir %_sysconfdir/syslog.d
%config(noreplace) %_sysconfdir/logrotate.d/*
%attr(-,uucp,adm) %_logdir/uucp
/sbin/reload-syslog

%changelog
* Thu Jul 31 2003 Dmitry V. Levin <ldv@altlinux.org> 1.4.1-alt12.1
- Build with explicitly enabled LFS suppport (#0002790).
- syslog-common: added /etc/syslog.d to explicit provides list.

* Tue Oct 29 2002 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt12
- rebuild with gcc3

* Tue Aug 13 2002 Dmitry V. Levin <ldv@altlinux.org> 1.4.1-alt11
- Fixed %_sysconfdir/syslog.d directory support.

* Fri May 31 2002 Dmitry V. Levin <ldv@altlinux.org> 1.4.1-alt10
- Shutup logrotate script (#0000891).
- Added "condreload" option to startup scripts.
- Added %ROOT/dev/log socket to %klogd_name subpackage.
- Additional convention enforcement on patch file names.

* Mon Apr 15 2002 Dmitry V. Levin <ldv@alt-linux.org> 1.4.1-alt9
- syslogd: added support for '-A' option and
  directory with symlinks on sockets to listen.
- syslog-common: added %_sysconfdir/syslog.d directory.
- klogd: added %_sysconfdir/syslog.d/klogd symlink
  to %ROOT/dev/log.

* Thu Feb 07 2002 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt8
- Resurrected one of our patches lost in previous release.
- syslogd is now running chrooted to /var/empty.
- syslogd init script: call restart instead of reload
  in case of syskogd is chrooted.

* Tue Feb 05 2002 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt7
- Merge with latest Owl patches:
  + Based the new klogd drop root patch on one from CAEN Linux.
  + Added syslogd patches derived from CAEN Linux to allow specifying a
    bind address for the UDP socket and to let syslogd run as non-root.
  + syslogd is now running as its dedicated pseudo-user, too.
+ klogd is now running chrooted to /var/lib/klogd.

* Tue Sep 25 2001 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt6
- New package syslog-common. Now logrotate be happy.

* Tue Jul 24 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4.1-alt5
- Corrected permissions on %_sysconfdir/syslog.conf
- Corrected startup scripts to use full pathnames.
- Patched klogd to reopen log socket on each ECONNRESET.

* Mon Jul 23 2001 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt4
- Splited to separate %syslog_name and %klogd_name packages.
- We will need it for syslog-ng.
- Added %_sysconfdir/sysconfig/* config scripts.

* Thu May 24 2001 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt3
- Rebuild to use new macros post_service and preun_service

* Thu May 10 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4.1-alt2
- Resurrected symlinks lost in prev release.

* Thu May 10 2001 Stanislav Ievlev <inger@altlinux.ru> 1.4.1-alt1
- Up to 1.4.1.
- Added patch from OpenWall.
- Fixed parent process killing bug.
- Chowned %_logdir/uucp to uucp user.

* Mon Mar 19 2001 Dmitry V. Levin <ldv@altlinux.ru> 1.4-ipl5mdk
- Fixed permissions.

* Wed Jan 24 2001 Dmitry V. Levin <ldv@fandra.org> 1.4-ipl4mdk
- Don't do busy loop when encounter two zero bytes
  (Troels Walsted Hansen <troels@thule.no>).

* Wed Dec 27 2000 Dmitry V. Levin <ldv@fandra.org> 1.4-ipl3mdk
 - Added PreReq on initscripts.

* Wed Dec 13 2000 Dmitry V. Levin <ldv@fandra.org> 1.4-ipl2mdk
- Added compatibility links for /var/log/{alert,boot.log,maillog,messages,secure,spooler}.

* Wed Sep 20 2000 Dmitry V. Levin <ldv@fandra.org> 1.4-ipl1mdk
- 1.4

* Thu Sep 14 2000 Dmitry V. Levin <ldv@fandra.org> 1.3.33-ipl2mdk
- Conflicts: vixie-cron < 3.0.1-ipl45mdk.

* Wed Sep 13 2000 Dmitry V. Levin <ldv@fandra.org> 1.3.33-ipl1mdk
- Completly rewritten syslog configuration.

* Fri Aug 25 2000 Frederic Crozat <fcrozat@mandrakesoft.com> 1.3.33-1mdk
- update to 1.3-33
- Correct logrotate config script to prevent rotating previous files

* Thu Aug 10 2000 Frederic Crozat <fcrozat@mandrakesoft.com> 1.3.31-15mdk
- add noreplace to make rpmlint happy

* Fri Jul 28 2000 Frederic Crozat <fcrozat@mandrakesoft.com> 1.3.31-14mdk
- BM + macroszification
- bzipped config files

* Tue May 17 2000 Yoann Vandoorselaere <yoann@mandrakeosft.com> 1.3.31-13mdk
- correct path to killall in syslog.log

* Thu May 04 2000 Yoann Vandoorselaere <yoann@mandrakeosft.com> 1.3.31-12mdk
- create the mail & news log directory.
- update syslog.log

* Tue May 02 2000 Yoann Vandoorselaere <yoann@mandrakeosft.com> 1.3.31-11mdk
- kern.* is now logged to kern.log
- much more logfile now (cron, syslog, kernel, mail.log, mail.warn,
  mail.err, mail.info, auth.log, user.log, lpr.log, daemon.log ).
- do not sync() not important logfile everytime an entry is added.
- syslog.conf.rhs -> syslog.conf.mdk
- mail & news log are in their own directory.
- again a little config change.

* Thu Mar 23 2000 Daouda Lo <daouda@mandrakesoft.com> 1.3.31-8mdk
- fix group for the next release 7.1
* Tue Oct 26 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Merge with rh changes.

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- bzip2 man/info pages
- add de locale
- fix handling of RPM_OPT_FLAGS

* Wed Feb 24 1999 Bill Nottingham <notting@redhat.com>
- update to sysklogd-1.3-31
- stop klogd *before* syslogd

* Tue Feb  9 1999 Jeff Johnson <jbj@redhat.com>
- escape naked percent chars in kernel messages (#1088).

* Thu Dec 17 1998 Jeff Johnson <jbj@redhat.com>
- rework last-gasp address-in-module oops trace for both 2.0.x/2.1.x modules.

* Mon Dec  7 1998 Jakub Jelinek <jj@ultra.linux.cz>
- make klogd translate SPARC register dumps and oopses.

* Tue Aug 11 1998 Jeff Johnson <jbj@redhat.com>
- add %clean

* Tue Aug  4 1998 Chris Adams <cadams@ro.com>
- only log to entries that are USER_PROCESS (fix #822)

* Mon Jul 27 1998 Jeff Johnson <jbj@redhat.com>
- remove RPM_BUILD_ROOT from %post

* Wed Apr 29 1998 Cristian Gafton <gafton@redhat.com>
- patch to support Buildroot
- package is now buildrooted

* Wed Apr 29 1998 Michael K. Johnson <johnsonm@redhat.com>
- Added exit patch so that a normal daemon exit is not flagged as an error.

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Wed Oct 29 1997 Donnie Barnes <djb@redhat.com>
- added (missingok) to init symlinks

* Thu Oct 23 1997 Donnie Barnes <djb@redhat.com>
- added status|restart support to syslog.init
- added chkconfig support
- various spec file cleanups

* Tue Jun 17 1997 Erik Troan <ewt@redhat.com>
- built against glibc
